<?php
/******************************************************************************
*  Xaseco2 plugin (TM2)                                                       
*  Description : Spectator waiting management   
*  Configuration: Editable (see below)                                                        
*                                                                             
*  Author: mikey                                                              
*  Version: 0.69                                                                 
******************************************************************************/   

Aseco::registerEvent('onStartup', 'SpecJamInit');
Aseco::registerEvent('onBeginMap', 'SpecJamNewMap');
Aseco::registerEvent('onChat', 'SpecJamChat');
Aseco::registerEvent('onRestartMap', 'SpecJamRestart');
Aseco::registerEvent('onPlayerConnect', 'SpecJamJoin');
Aseco::registerEvent('onPlayerDisconnect', 'SpecJamLeft');
Aseco::registerEvent('onPlayerInfoChanged', 'SpecJamChanged');
Aseco::registerEvent('onPlayerFinish', 'SpecJamIdle');
Aseco::registerEvent('onEndRound', 'SpecJamInterval');
Aseco::registerEvent('onEndMap', 'SpecJamPodium');
Aseco::registerEvent("onEverySecond", "countSpecJam");
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'specJamClick');
Aseco::addChatCommand('spec', 'SpecJam info');


function SpecJamInit($aseco) {
  global $aseco, $spec_cfg, $jam;

// Start config paramaters *Edit 
  $spec_cfg['WaitMax'] = 8;               // Number of slots available in waiting line
  $spec_cfg['Worst'] = 2;                 // Number of players to Kick each race end , use zero to disable
  $spec_cfg['Kick'] = 1;                  // Kick Method 0=Kick 1=Force to Spec 2=Force to Spec & add to wait
  $spec_cfg['Admin'] = false;             // Kick admins (only if kick is used) false = force to spec
  $spec_cfg['Idle'] = 3;                  // Number of maps before kicking idle players, use -1 to disable
// End config paramaters 

  $jam['WaitList'] = array_fill(0,$spec_cfg['WaitMax']+2,-1);
  $jam['WaitList'][0] = 0;                // The waiting list
  $jam['PlayList'] = array(0);            // Map start playing list 
  $jam['PlayMax'] = 0;                    // Server Max Players 
  $jam['SpecMax'] = 0;                    // Server Max Spectators 
  $jam['Players'] = 0;                    // Current Number of Players 
  $jam['Specers'] = 0;                    // Current Number of Spectators 
  $jam['Ticker'] = 5;                     // SpecJam main ticker  
  $jam['Checker'] = 0;                    // Check wait ticker  
  $jam['Status'] = 0;                     // Plugin Status  
  $jam['Results'] = array();              // Finish results
  $jam['Release'] = array();              // Release slot list
  $jam['Idle'] = array();                 // idle tracking
}


function chat_spec($aseco, $command) {
  global $aseco, $spec_cfg, $jam;
  $player = $command['author'];
  $login = $player->login;
  $msg = '$i$FF0For Admin usage only';
  $arglist = explode(' ', $command['params'], 2);   // split params into arrays & insure optional parameters exist
  if (!isset($arglist[1])) $arglist[1] = '';
  $command['params'] = explode(' ', preg_replace('/ +/', ' ', $command['params']));
  if (!isset($command['params'][1])) $command['params'][1] = '';
  $wait = 1 ;
  $msg = '$F80Spec Waiting $DDD'.$jam['WaitList'][0].'$F80/$ddd'.$spec_cfg['WaitMax'].'$F80 : $DDD';  
  while($wait<=$spec_cfg['WaitMax']){
    if ($jam['WaitList'][$wait]!= -1)$msg .= $jam['WaitList'][$wait].', ';
    $wait++ ;
  }
  
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {   // admin
    if ($command['params'][0] == 'help' || '?') {
      $msg = '$i$FF0Usage: /spec list, /spec forceplay login, /spec worst x (0=Disabled, Currently=$fff'.$spec_cfg['Worst'].'$FF0)' ;
    }
    if ($command['params'][0] == 'worst') {
      $msg = '$F80Worst Kick set to $FFF'.intval($command['params'][1]);
      if ($command['params'][1]==0) $msg = '$F80Worst Kick $FFFDisabled';
      $spec_cfg['Worst']= intval($command['params'][1]);
    }
    if ($command['params'][0] == 'forceplay') {
      $who = $command['params'][1];
      $msg = '$F80Login $FFF'.$who.' $f80 has been forced into play.';
      $aseco->client->addCall('ForceSpectator', array($who,2));
      $aseco->client->addCall('ForceSpectator', array($who,0));
    }
    if ($command['params'][0] == 'list') {  
      $wait = 1 ;
      $msg = '$F80Spec Waiting $DDD'.$jam['WaitList'][0].'$F80/$ddd'.$spec_cfg['WaitMax'].'$F80 , $DDD';  
      while($wait<=$spec_cfg['WaitMax']){
        if ($jam['WaitList'][$wait]!= -1)$msg .=$jam['WaitList'][$wait]. ', ';
        $wait++ ;
      }
    }
  }
  $aseco->client->query('ChatSendServerMessageToLogin', $msg, $login);     
}


function SpecJamNewMap($aseco, $map) {            // new map
  global $aseco, $spec_cfg, $jam;
  $jam['Status'] = 1; 
  $jam['Checker'] = 0;
  $jam['PlayList'] = array (0);
  $jam['PlayMax'] = $aseco->server->maxplay ;
  $jam['SpecMax'] = $aseco->server->maxspec ;
  $plyrlist= $aseco->server->players->player_list;
  $play = 0;
  $spec = 0;
  foreach($plyrlist as $data) {
    if (!$data->isspectator) {                    // create starting player list
      $play++;
      $jam['PlayList'][$play]=$data->login;
    } else {                                      // check spectators
      $spec++;
      $aseco->client->addCall('ForceSpectator', array($data->login,1));                         // Redundant ?
      $aseco->client->addCall('SpectatorReleasePlayerSlot', array($data->login));               // bug safe guard ?
      
      if (array_search($data->login, $jam['WaitList'])==false && $data->ladderscore > $aseco->server->laddermin) {
        joinwait_manialink($aseco, $data->login);

      }  
    } 
  }
  $jam['PlayList'][0] =$play;
  $jam['Players'] =$play; 
  if ($jam['Checker'] <= $jam['Ticker']) $jam['Checker']=$jam['Ticker']+5 ; //checkwait($aseco);
}


function SpecJamRestart($aseco, $player) {        // map restart
  global $aseco, $spec_cfg, $jam;
  $jam['Status'] = 3;
  } 


function SpecJamChat($aseco, $chat) { 
  global $aseco, $spec_cfg, $jam;
  if ($chat[0] == $aseco->server->id) return;     // server msg
  if (trim($chat[2]) == trim('/admin skip')) {
    $jam['Status'] = 3;
  }
  $login = $chat[1];
  $jam['Idle'][$login] = 0;
}


function SpecJamJoin($aseco, $player) {           // player join
  global $aseco, $spec_cfg, $jam;
  $login = $player->login;
  $jam['Idle'][$login] = 0;

  if ($player->isspectator > 0 ) {                // do manialink for join list, Force spec not user selectable
    if ($player->ladderscore > $aseco->server->laddermin) {
      joinwait_manialink($aseco, $login);
      $aseco->client->addCall('ForceSpectator', array($login,1));        
      $msg = '$ff8$s$iClick on the  $fff$ijoin spectator waiting list$ff8$i button to play !';
    } else {
      $msg = '$f00$s$iYou do not have enough ladder points to play, spectate only !';
    }
    $aseco->client->addCall('ChatSendServerMessageToLogin', array($aseco->formatColors($msg),$login));   
  }
}


function SpecJamLeft($aseco, $player) {           // player left
  global $aseco, $spec_cfg, $jam;
  $login = $player->login;                        
  unset ($jam['Idle'][$login]) ;
  $aseco->client->query('SpectatorReleasePlayerSlot', $login);
  $playing= array_search($login, $jam['PlayList']);	

  $waiting= array_search($login, $jam['WaitList']);
  if ($waiting >0) {
    $jam['WaitList'][$waiting]=-1;
    $jam['WaitList'][0]--;
    $nick= $aseco->server->players->player_list[$login]->nickname ; 
    $msg = $nick .'$z$ff8$s$i has left the spectator waiting list.' ;
    $aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($msg)));  
  } 
  $jam['Checker']=$jam['Ticker']+4;   
}


function SpecJamChanged($aseco, $player) {        // player new info
  global $aseco, $spec_cfg, $jam;
  $login = $player['Login'];
  $spec = substr($player['SpectatorStatus'], -1, 1);
  $hasslot = $player['Flags'];

  if ($spec==1) {
    $playslot=array_search($login, $jam['PlayList']);
    if ($playslot>0) {     // was a player
      $aseco->client->query('ForceSpectator', $login,1);
      $aseco->client->addCall('SpectatorReleasePlayerSlot', array($login));
      $jam['Checker']=$jam['Ticker']+4;  
    }
  } 
  if ($jam['Checker'] <= $jam['Ticker']) $jam['Checker']=$jam['Ticker']+6 ;   
}


function SpecJamIdle($aseco, $finish_data) { 
  global $aseco, $spec_cfg, $jam;
  $login = $finish_data->player->login; 
  if ($finish_data->score > 0) $jam['Idle'][$login] = 0;
}

function countSpecJam($aseco, $command) {              // every second , ticker
  global $aseco, $spec_cfg, $jam;
  $jam['Ticker']++;
  if ($jam['Ticker']==4) kickworst($aseco); 
  if ($jam['Checker'] == $jam['Ticker']) checkwait($aseco); 
  if ($jam['Ticker']/25==round($jam['Ticker']/25)) SpecJamInterval($aseco,0); 
  
  if ($jam['Ticker']==40 || $jam['Ticker']==290) {     // bug catcher ?
    $aseco->client->query('GetPlayerList',255,0,1); 
    $svrlist = $aseco->client->getResponse();
    
    foreach($svrlist as $dat) {	                
      $specstat = substr($dat['SpectatorStatus'], -1, 1);
      $flags = $dat['Flags'];
      $login = $dat['Login'] ;
      if ($specstat==1 && $dat['Flags']>999999) {
//        print('<Interval> Fixing! PLAYERSLOT NOT RELEASED '.$dat['Login'].' , SpecStat='.$dat['SpectatorStatus'].' , flags='.$dat['Flags']." \n\r");    // debug
        $aseco->client->query('SpectatorReleasePlayerSlot', $dat['Login']);
      }
    } 
  }
}


function SpecJamInterval($aseco, $command) {          // Every x seconds + EndRound
  global $aseco, $spec_cfg, $jam;
  if ($jam['Status'] == 2) return;
  $plyrlist= $aseco->server->players->player_list;
  $play = 0;
  $spec = 0;
  foreach($plyrlist as $data) {	  
    if ($data->isspectator) {                    
      $spec++;
      if (array_search($data->login, $jam['WaitList'])==false && $data->ladderscore > $aseco->server->laddermin) {
        joinwait_manialink($aseco, $data->login);     // update waiting stats
       }
    } else $play++;                                     
  }
  checkwait($aseco);
}


function SpecJamPodium($aseco, $command) {            // EndRace
  global $aseco, $spec_cfg, $jam;
  if ($jam['Status'] == 1) $jam['Status'] = 2;
  $jam['Results'] = $command[0];
  $jam['Ticker'] = 0;
                                                          // clear manialinks
  $xml = '<manialink id="0815470000271"> </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPage', array($xml, -1, false));
  $xml = '<manialink id="0815470000272"> </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPage', array($xml, -1, false));
  $xml = '<manialink id="0815470000273"> </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPage', array($xml, -1, false));

  $plyrlist= $aseco->server->players->player_list;
  foreach($plyrlist as $data) {	                          // idle check
    if ($jam['Idle'][$data->login]>=$spec_cfg['Idle'] && array_search($data->login, $jam['PlayList'])>0 ) {
      $msg = $data->nickname. '$z$ff8$s$i Has been forced to spectator for no activity.';
      $aseco->client->query('ForceSpectator', $data->login, 1);
      $aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($msg))); 
      $aseco->client->addCall('SpectatorReleasePlayerSlot', array($data->login)); 
    }
    if ($jam['Idle'][$data->login]>=(2*$spec_cfg['Idle']) && !array_search($data->login, $jam['WaitList'])>0) {  // !not on wait list
      $msg = $data->nickname. '$z$ff8$s$i Has been kicked for no activity.';
      $aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($msg)));  
      $aseco->client->addCall('Kick', array($data->login));
    }  
  }
  updatewait_manialink($aseco);  
}




function specJamClick($aseco, $answer) {          // $answer[0]=PlayerUid, $answer[1]=Login, $answer[2]=Answer
  global $aseco, $spec_cfg, $jam;
  $login =	$answer[1];
  $player = $aseco->server->players->getPlayer($answer[1]);
	$jam['Idle'][$login] = 0;			
  if ($answer[2] == 2702701) {                    // joined waiting list
    if ($jam['WaitList'][0] >= $spec_cfg['WaitMax']) return;
    $xml = '<manialink id="0815470000271"> </manialink>';
    $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, -1, false));
    addwait($aseco,$login) ;
    if ($jam['Checker'] <= $jam['Ticker']) $jam['Checker']=$jam['Ticker']+2 ; //checkwait($aseco);
	} 
  if ($answer[2] == 2702702) {                   // open leave button
    leavewait_manialink($aseco,$login) ;
    if ($jam['Checker'] <= $jam['Ticker']) $jam['Checker']=$jam['Ticker']+2 ; //checkwait($aseco);
  }
  if ($answer[2] == 2702703) {                  // leave wait list
    $xml = '<manialink id="0815470000272"> </manialink>';
    $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, -1, false));
    $xml = '<manialink id="0815470000273"> </manialink>';
    $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, -1, false));
    $left= array_search($login, $jam['WaitList']);
    if ($left >0) {
      $jam['WaitList'][$left]=-1;
      $jam['WaitList'][0]--;
    } 
    if ($jam['Checker'] <= $jam['Ticker']) $jam['Checker']=$jam['Ticker']+2 ;
    joinwait_manialink($aseco, $login);
    $nick= $aseco->server->players->player_list[$login]->nickname ; 
    $msg = $nick .'$z$ff8$s$i has left the spectator waiting list.' ;
    $aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($msg)));  
  }  
  
  if ($answer[2] == 23) { 
    $jam['Status'] = 3;  
  }
} 

// functions that are called from within function-events

function addwait($aseco,$login) {
  global $aseco, $spec_cfg, $jam;
  $exist= array_search($login, $jam['WaitList']);
  if ($exist>0) return ;
  $loop = 1;
  while ($loop <= $spec_cfg['WaitMax']) {

    if ($jam['WaitList'][$loop]==-1) {            // Waiting slot is available
      $jam['WaitList'][$loop]=$login;
      $jam['WaitList'][$loop+1]=-1;
      $jam['WaitList'][0]++;
      $loop=$spec_cfg['WaitMax']+1;
    }
    $loop++;  
  }
}   


function kickworst($aseco) {
  global $aseco, $spec_cfg, $jam;
  $starters= 0;
  $finishers = 0 ; 
  $play = 0;
  $spec = 0;
  $plyrlist= $aseco->server->players->player_list;
  foreach($plyrlist as $data) {	                          // count players + spec
    if ($jam['Status'] != 3) $jam['Idle'][$data->login]++;
    if (!$data->isspectator) $play++;
    else $spec++;    
    $check=1;
    while ($check <= $jam['PlayMax']+$jam['SpecMax']) {   // count starting players remaining
      if (isset($jam['PlayList'][$check]) && $data->login == $jam['PlayList'][$check]) $starters++; 
      $check++;  
    }
  }  
  foreach($jam['Results'] as $data) {                     // count finishers
    if ($data['Rank'] > 0) $finishers++;
    }
  if ($jam['PlayMax'] > $finishers) $kick=0;
  else $kick=$spec_cfg['Worst']-($finishers-$starters);   // less kicks if players left mid race
  if ($kick > $jam['WaitList'][0]) $kick=$jam['WaitList'][0];
  if ($jam['Status'] == 3) $kick=0; 
  $worst = $finishers ; 

  while($kick > 0) {
    foreach($jam['Results'] as $data) {
      $action=$spec_cfg['Kick'];
      if ($data['Rank'] == $worst && array_search($data['Login'], $jam['PlayList'])>0) {    // worst + starter
        if ($jam['WaitList'][0] >= $spec_cfg['WaitMax'] && $spec_cfg['Kick'] ==2) $action=1;        // if too many waiting, no requeque
        if ($aseco->isMasterAdmin($data['Login']) && $spec_cfg['Admin'] != true) $action=1;
        if ($aseco->isAdmin($data['Login']) && $spec_cfg['Admin'] != true) $action=1;
        if ($spec >= $jam['SpecMax']) $action=0;        // if too many spec, kick
        if ($action ==0) {                              // kick
          $msg = $data['NickName'] .'$z$ff8$s$i has been Kicked, for worst place finish.' ;
          $aseco->client->query('Kick', $data['Login']);
          $aseco->client->addCall('SpectatorReleasePlayerSlot', array($data['Login']));
        }   
        if ($action >0 ) {                              // Force to spec 
          $msg = $data['NickName'] .'$z$ff8$s$i has been forced to spectator, for worst placed finish.' ;
          $aseco->client->query('ForceSpectator', $data['Login'], 1);
          $aseco->client->addCall('SpectatorReleasePlayerSlot', array($data['Login']));
          if ($action ==2 && $jam['WaitList'][0]<$spec_cfg['WaitMax']) addwait($aseco,$data['Login']) ;    // add to waiting list
          $spec++;
        } 
        $kick--;
        $aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($msg))); 
      }
    } 
  $worst--;                                                        
  } 
  $jam['Checker'] = $jam['Ticker']+5 ;     
}    


function checkwait($aseco) {
  global $aseco, $spec_cfg, $jam;
  $plyrlist= $aseco->server->players->player_list;
  $loop=1;
  $waiting=0;
  while ($loop<=$spec_cfg['WaitMax']) {             // update waiting list  
    if ($jam['WaitList'][$loop]==-1) {
      $shift=$loop;
      while ($shift<=$spec_cfg['WaitMax']) {
        $jam['WaitList'][$shift]=$jam['WaitList'][$shift+1];          
        $jam['WaitList'][$shift+1]= -1;
        $shift++;
      }
    }
    if ($jam['WaitList'][$loop] !=-1) $waiting++;
    $loop++;  
  }
  $jam['WaitList'][0]=$waiting;                     // update number waiting 
  $play = 0;
  $spec = 0;
  foreach($plyrlist as $data) {	                    // count current players     
    if (!$data->isspectator) $play++;
    else $spec++;
  }     
 
  $jam['Players']=$play;
  $count=$jam['PlayMax']-$jam['Players'];    
  while($count>0) {                                 // if current less than max force to play
    if ($jam['WaitList'][1] != -1) {
      $nick=$aseco->server->players->player_list[$jam['WaitList'][1]]->nickname ;   
      $msg = $nick .'$z$s$ff8$i has joined play !' ;    
      $aseco->client->query('ForceSpectator', $jam['WaitList'][1], 2);   
      $aseco->client->addCall('ForceSpectator', array($jam['WaitList'][1],0));
      $aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($msg))); 
      $xml = '<manialink id="0815470000272"> </manialink>';
      $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($jam['WaitList'][1], $xml, -1, false));
      $xml = '<manialink id="0815470000273"> </manialink>';
      $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($jam['WaitList'][1], $xml, -1, false));
      $jam['Idle'][$jam['WaitList'][1]]=1;
      $loop=1;

      while ($loop<=$spec_cfg['WaitMax']) {
        $jam['WaitList'][$loop]=$jam['WaitList'][$loop+1];
        $loop++;
      }
      $jam['WaitList'][$spec_cfg['WaitMax']]=-1;
      $jam['WaitList'][0]--;
      
    }
  $count--;  
  }
  updatewait_manialink($aseco);  
}

  
function joinwait_manialink($aseco, $login) {
  global $aseco, $spec_cfg, $jam;
  $xml = '<manialink id="0815470000272"> </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, -1, false));
  $xml = '<manialink id="0815470000273"> </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, -1, false));
  if ($jam['Status'] == 1) {
    if ($jam['WaitList'][0] < $spec_cfg['WaitMax']) {
     $message = '$0ff$sClick to join spectator waiting list';
    } else {
      $message='$f00The waiting list is full !';
    }
    $xml = '<manialink id="0815470000271">
      <format style="TextStaticSmall" textsize="1" />
        <frame posn="0 35 0">
          <quad posn="0 0 0" sizen="30 6.0"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgPlayerName" action="2702701"/>
          <quad posn="-14.3 2.5 1" sizen="5 5" style="Icons64x64_1" substyle="Camera" action="2702701"/>
          <label posn="2.7 1.5 1" sizen="26 4" halign="center" valign="center" scale="0.8 0.8" text="$aaaStatus: Non playing spectator      Waiting: '.$jam['WaitList'][0].'/'.$spec_cfg['WaitMax'].'" action="2702701"/>
          <label posn="2.7 -0.7 1" sizen="26 4" halign="center" valign="center" scale="1.0 1.0" text="'.$message.'" action="2702701"/>
        </frame>
    </manialink>'; 
  $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));   
  } 
}     


function updatewait_manialink($aseco) {
  global $aseco, $spec_cfg, $jam;
  $posi = 1;
  while ($posi <= $spec_cfg['WaitMax']) {
    if ($jam['WaitList'][$posi] != -1) {          // is player waiting ?
      if ($jam['Status'] == 1) {            
        $xml = '<manialink id="0815470000272">
          <format style="TextStaticSmall" textsize="1" />
            <frame posn="0 35 0">
              <quad posn="0 0 0" sizen="30 6.0"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgCardSystem" />
              <quad posn="-14.3 2.5 1" sizen="5 5" style="Icons64x64_1" substyle="CameraLocal" action="2702702"/>
              <label posn="2.7 1.5 1" sizen="26 4" halign="center" valign="center" scale="0.8 0.8" text="$aaaStatus: Waiting spectator       Waiting: '.$jam['WaitList'][0].'/'.$spec_cfg['WaitMax'].'" action="2702702"/>
              <label posn="2.7 -0.7 1" sizen="26 4" halign="center" valign="center" scale="1.0 1.0" text="$eeeCurrently waiting position $fff$s'.$posi.'" action="2702702"/>
              </frame>
            </manialink>'; 
        $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($jam['WaitList'][$posi], $xml, 0, false));
      }
      if ($jam['Status'] == 2) {
        $xml = '<manialink id="0815470000272">
          <format style="TextStaticSmall" textsize="1" />
            <frame posn="29.4 -24.75 0">
              <quad posn="0 0 0" sizen="7.0 4.0"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgCardSystem" />
              <quad posn="-2.8 2 1"  sizen="4 4" style="Icons64x64_1" substyle="CameraLocal" action="2702702"/>
              <label posn="2.2 0.2 1" sizen="4 4" halign="center" valign="center" scale="1.0 1.0" text="$FFF'.$posi.'" action="2702702"/>
              </frame>
            </manialink>'; 
        $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($jam['WaitList'][$posi], $xml, 150000, false));
      }  
    }
  $posi++;  
  }
}

function leavewait_manialink($aseco,$login) {
  global $aseco, $spec_cfg, $jam;
  if ($jam['Status'] == 1) {
    $xml = '<manialink id="0815470000273">
        <format style="TextStaticSmall" textsize="1" />
          <frame posn="0 30.6 0">
            <quad posn="0 0 0" sizen="30 3.0"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgCardSystem" action="2702703"/>
            <label posn="0 0.2 1" sizen="26 4" halign="center" valign="center" scale="0.9 0.9" text="$fffClick to leave the waiting list" action="2702703"/>
          </frame>
        </manialink>'; 
    $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));
    }
 
  }
?>     